/*
   Copyright (c) 2009-2011, Jack Poulson
   All rights reserved.

   This file is part of Elemental-FLAME.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

    - Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.

    - Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

    - Neither the name of the owner nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE.
*/
#ifndef ELEMENTAL_DIST_MATRIX_HPP
#define ELEMENTAL_DIST_MATRIX_HPP 1

#include "elemental/matrix.hpp"

#include "elemental/dist_matrix/forward.hpp"

#include "elemental/dist_matrix/abstract.hpp"
#include "elemental/dist_matrix/mc_mr.hpp"
#include "elemental/dist_matrix/mc_star.hpp"
#include "elemental/dist_matrix/md_star.hpp"
#include "elemental/dist_matrix/mr_mc.hpp"
#include "elemental/dist_matrix/mr_star.hpp"
#include "elemental/dist_matrix/star_mc.hpp"
#include "elemental/dist_matrix/star_md.hpp"
#include "elemental/dist_matrix/star_mr.hpp"
#include "elemental/dist_matrix/star_star.hpp"
#include "elemental/dist_matrix/star_vc.hpp"
#include "elemental/dist_matrix/star_vr.hpp"
#include "elemental/dist_matrix/vc_star.hpp"
#include "elemental/dist_matrix/vr_star.hpp"

#endif /* ELEMENTAL_DIST_MATRIX_HPP */

